//***************************************************************************
//* ` u q n  p  p L q
//*
//* ԍ	: AVR314
//* ̧ٖ	: "dtmf.c"
//* \	: DTMF
//* t	: 00.06.27
//* 		: 1.0
//* ړIMCU	: SRAM,8̓o,PWMAVR̂ǂ
//*
//* 
//* ̉pLq͒P8ޯPWMo͂gpDTMF𐶐@Lq܂B
//*
//***************************************************************************

#include	<stdio.h>
#define		__IAR_SYSTEMS_ASM__
#include	<io4414.h>
#include	"ina90.h"

#define		Xtal		8000000			//  ۯg(Hz)
#define		prescaler	1				// /1Ou
#define		N_samples	128				// Qƕ\̌{
#define		Fck			Xtal/prescaler	// /1g
#define		delaycyc	10				// ߰Bݒ͒x

//****************************************************************************
// g\
// {\:7ޯėʎq128{ŕW{ꂽ1
//****************************************************************************

flash unsigned char auc_SinParam [128] = {
 64, 67, 70, 73, 76, 79, 82, 85,
 88, 91, 94, 96, 99,102,104,106,
109,111,113,115,117,118,120,121,
123,124,125,126,126,127,127,127,
127,127,127,127,126,126,125,124,
123,121,120,118,117,115,113,111,
109,106,104,102, 99, 96, 94, 91,
 88, 85, 82, 79, 76, 73, 70, 67,
 64, 60, 57, 54, 51, 48, 45, 42,
 39, 36, 33, 31, 28, 25, 23, 21,
 18, 16, 14, 12, 10,  9,  7,  6,
  4,  3,  2,  1,  1,  0,  0,  0,
  0,  0,  0,  0,  1,  1,  2,  3,
  4,  6,  7,  9, 10, 12, 14, 16,
 18, 21, 23, 25, 28, 31, 33, 36,
 39, 42, 45, 48, 51, 54, 57, 60};

//****************************************************************************
// ݊Ԋu(x_SW)\
// 8{x_SW\: x_SW=ľܓ(8~N_samples~f~510Fck)
//****************************************************************************

const unsigned char auc_frequencyH [4] = {
107, 96, 87, 79};							// Qg(s),1633Hz,1477Hz,1336Hz,1209Hz

const unsigned char auc_frequencyL [4] = {
 61, 56, 50, 46};							// Qg(),941Hz,852Hz,770Hz,697Hz


// * S̕ϐ *
unsigned char	x_SWa		= 0x00;			// Qg݊Ԋu
unsigned char	x_SWb		= 0x00;			// Qg݊Ԋu
unsigned int	X_LUTaExt	= 0;			// LUT̎gAʒu(g`)
unsigned int	X_LUTbExt	= 0;			// LUT̎gBʒu(g`)
unsigned int	X_LUTa;						// LUT̎gAʒu(`)
unsigned int	X_LUTb;						// LUT̎gBʒu(`)

// * /1ꊄ荞ݏٰ *

void interrupt [TIMER1_OVF1_vect] ISR_T1_Overflow (void)
{ 
  X_LUTaExt += x_SWa;								// ݊Ԋuʒuwqړ
  X_LUTbExt += x_SWb;
  X_LUTa = (char)(((X_LUTaExt+4) >> 3)&(0x007F));	// ꎞʒuwqW(`)
  X_LUTb = (char)(((X_LUTbExt+4) >> 3)&(0x007F));
													// PWMlvZ:Qgl+3/4Qgl
  OCR1A = (auc_SinParam[X_LUTa] + (auc_SinParam[X_LUTb]-(auc_SinParam[X_LUTb]>>2)));
}

// *  *

void init (void)
{
  TIMSK  = 0x80;					// /1ꊄ荞݋
  TCCR1A = (1<<COM1A1)+(1<<PWM10);	// 񔽓]8ޯPWMݒ
  TCCR1B = (1<<CS10);				// OuȂ(1/1)ŋN
  DDRD   = (1 << PD5);				// PD5(OC1A)o͐ݒ
  _SEI();							// S̊荞݋
}

// * ߰Bݒ̐͂ۏ؂邽߂̒x *

void Delay (void)
{
	int i;
	for (i = 0; i < delaycyc; i++) _NOP();
}

//****************************************************************************
// MAIN
// ǂ̉𐶐邩(ႦΕ]̽gp)߰Bǂ݁AQ
// g(s)ƒQg()̍߁Ax_SWax_SWb߂܂B
//   PINB
// s  PINB
//****************************************************************************

void main (void)
{
  unsigned char uc_Input;
  unsigned char uc_Counter = 0;
  init();									// 
  for(;;){
											//  - Qg()
	DDRB  = 0x0F;							// ٓ,ُo͐ݒ
	PORTB = 0xF0;							//  ٱ, Lowo͐ݒ
	uc_Counter = 0;							// ޯČv평
	Delay();								// ߰Đݒx
	uc_Input = PINB;						// l擾
	do
	{
	  if(!(uc_Input & 0x80))				// Ήޯ(MSB)̷(=Low)
	  {										// ȂA
		x_SWb = auc_frequencyL[uc_Counter];	// ΉQ݊Ԋul擾
		uc_Counter = 4;						// ޯČvɏIlݒ
	  }
	  else									// ȂȂA
	  {
		x_SWb = 0;							// Qg݊Ԋu
	  }
	  uc_Counter++;							// ޯČvis
	  uc_Input = uc_Input << 1;				// ޯĒl1ޯčړ
	} while ((uc_Counter < 4));				// 4ޯĕ܂Ōp

											//  - Qg(s)
	DDRB  = 0xF0;							// ُo,ٓ͐ݒ
	PORTB = 0x0F;							//  Lowo, ٱߐݒ
	uc_Counter = 0;							// ޯČv평
	Delay();								// ߰Đݒx
	uc_Input = PINB;						// l擾
	uc_Input = uc_Input << 4;				// ققֈړ
	do 
	{
	  if(!(uc_Input & 0x80))				// Ήޯ(MSB)̷(=Low)
	  {
		x_SWa = auc_frequencyH[uc_Counter];	// ΉQ݊Ԋul擾
		uc_Counter = 4;						// ޯČvɏIlݒ
	  }
	  else									// ȂȂA
	  {
		x_SWa = 0;							// Qg݊Ԋu
	  }
	  uc_Counter++;							// ޯČvis
	  uc_Input = uc_Input << 1;				// ޯĒl1ޯčړ
	} while (uc_Counter < 4);				// 4ޯĕ܂Ōp
  }
}

